<template>
    <div>
        <table class="table users-table">
            <thead>
            <tr>
                <th>infos</th>
                <th>groups</th>
                <th>rights on screeners</th>
                <th>active account</th>
                <th>delete user</th>
            </tr>
            </thead>
            <tbody>
            <tr v-for="user in users">
                <td>
                    <div class="users-table__info">
                        <div class="users-table__info__text">
                            <span class="users-table__info--bold">{{ user.name  }} {{ user.surname }}</span>

                            <span>{{ user.job_title }}, {{ user.company_name }}</span>
                        </div>

                        <button @click="showUserInfo(user)" class="users-table__btn">see infos</button>
                    </div>
                </td>
                <td>
                    <ul class="users-table__group-list">
                        <li v-for="group in user.teams">{{ group.name }},</li>
                    </ul>
                    <div class="users-table__btn-block">
                        <button @click="showGroups = true" class="users-table__btn">edit groups</button>
                    </div>
                </td>
                <td class="permission">
                    <div class="permission__block">
                        <i class="fa fa-eye permission__icon" aria-hidden="true"></i>
                        <label class="checkbox">

                            <input type="checkbox" :checked="user.permission.view == 1"
                                   @click="changePermission(user.permission.id, 'view', $event)">
                            <span class="checkmark-small"></span>
                        </label>
                    </div>

                    <div class="permission__block">
                        <i class="fa fa-commenting-o permission__icon" aria-hidden="true"></i>

                        <label class="checkbox">
                            <input type="checkbox" :checked="user.permission.chat == 1"
                                   @click="changePermission(user.permission.id, 'chat', $event)">
                            <span class="checkmark-small"></span>
                        </label>
                    </div>

                    <div class="permission__block">
                        <i class="fa fa-check-circle-o permission__icon" aria-hidden="true"></i>

                        <label class="checkbox">
                            <input type="checkbox" :checked="user.permission.publish == 1"
                                   @click="changePermission(user.permission.id, 'publish', $event)">
                            <span class="checkmark-small"></span>
                        </label>
                    </div>
                </td>
                <td class="active-account">
                    <label class="checkbox">
                        <input type="checkbox" :checked="user.is_validate == 1"
                               @click="changeActiveStatus(user.id, $event)">
                        <span class="checkmark-small"></span>
                    </label>
                </td>
                <td class="user-delete">
                    <div class="request-table__btn">
                        <button @click="deleteUser(user.id)"><i class="fa fa-trash-o" aria-hidden="true"></i></button>
                    </div>
                </td>
            </tr>
            </tbody>
        </table>

        <el-dialog
                title="Informations"
                :visible.sync="showUser"
                width="50%">
            <edit-user :user="user" />
        </el-dialog>

        <el-dialog
                title="Groups"
                :visible.sync="showGroups"
                width="50%">
            <groups/>
        </el-dialog>
    </div>
</template>

<script>
    import getData from '../mixins/getData'
    import Groups from './Groups'
    import EditUser from './EditUser'

    export default {
        name: 'Users',
        components: {Groups, EditUser},
        props: {
            usersData: {
                require: true
            }
        },
        data() {
            return {
                users: this.usersData,
                user: [],
                showUser: false,
                showGroups: false,
                opacity: false
            }
        },
        mixins: [getData],
        methods: {
            deleteUser(id) {
                this.asyncGetData({
                    method: 'DELETE',
                    url: 'admin/user/delete',
                    data: {
                        user_id: id
                    }
                }).then(response => {
                    if (response.status) {
                        this.users = response.data
                        // Success message
                        this.$message({
                            message: 'User Successfully deleted.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            changePermission(id, permission, event) {
                this.asyncGetData({
                    method: 'PUT',
                    url: 'admin/user/change/permission',
                    data: {
                        permission_id: id,
                        permission,
                        status: event.target.checked ? 1 : 0
                    }
                }).then(response => {
                    if (response.status) {
                        // Success message
                        this.$message({
                            message: 'Active status successfully changed.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            changeActiveStatus(id, event) {
                this.asyncGetData({
                    method: 'PUT',
                    url: 'admin/user/change/active/status',
                    data: {
                        user_id: id,
                        status: event.target.checked ? 1 : 0
                    }
                }).then(response => {
                    if (response.status) {
                        // Success message
                        this.$message({
                            message: 'Active status successfully changed.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            showUserInfo(user) {
                this.showUser = true
                this.user = user
            }
        }
    }
</script>